// debord_intsig.c
// Test de rebouclage sur entiers positifs
//
#include <stdio.h>

#define CHARS          127   // 1 de signe + 7 bits de valeur
#define SHORTS       32767   // 1+15 bits
#define INTS    2147483647   // 1+31 bits
#define LONGS   2147483647   // 
#define QT 7

int main(int argc, char *argv[])
{
  int i = 0;

  printf("// Test de rebouclage des entiers avec signe (debord_intsig.c) \n");

  char sch = CHARS-2;
  printf("\nRebouclage  char\n");
  for (i = 1; i<QT; i++) {
    printf("%d\t", sch);
    sch++;
  }
  printf("\n\nRebouclage  short\n");
  short ssh = SHORTS-2;
  for (i = 1; i<QT; i++) {
    printf("%d\t", ssh);
    ssh++;
  }
  printf("\n\nRebouclage  int\n");
  int sin = INTS-2;
  for (i = 1; i<QT; i++) {
    printf("%d\t", sin);
    sin++;
  }
  printf("\n\nRebouclage  long\n");
  long slo = LONGS-2;
  for (i = 1; i<QT; i++) {
    printf("%ld\t", slo);
    slo++;
  }
  printf("\n");
  char sch1, sch2, sch3;
  sch1 = 100;
  sch2 =  60;
  sch3 = sch1 + sch2;
  printf("\nAddition rebouclante de deux char (fausse) : %d + %d = %d \n", sch1, sch2, sch3);

  return 0;
}