// debord_intpos.c
// Test de rebouclage sur entiers positifs
//
#include <stdio.h>

#define CHARU          255   // 8 bits pour 256 valeurs (0...255)
#define SHORTU       65535   // 65536
#define INTU    4294967295   // 2097152 ou 4194304
#define LONGU   4294967295   // 2147483648 ou 4294967296
#define QT 7

int main(int argc, char *argv[])
{
  unsigned int i = 0;

  printf("Test de rebouclage des entiers sans signe (debord_intpos.c) \n");

  unsigned char uch = CHARU-2;
  printf("\nRebouclage unsigned char\n");
  for (i = 1; i<QT; i++) {
    printf("%u\t", uch);
    uch++;
  }
  printf("\n\nRebouclage unsigned short\n");
  unsigned short ush = SHORTU-2;
  for (i = 1; i<QT; i++) {
    printf("%u\t", ush);
    ush++;
  }
  printf("\n\nRebouclage unsigned int\n");
  unsigned int uin = INTU-2;
  for (i = 1; i<QT; i++) {
    printf("%u\t", uin);
    uin++;
  }
  printf("\n\nRebouclage unsigned long\n");
  unsigned long ulo = LONGU-2;
  for (i = 1; i<QT; i++) {
    printf("%lu\t", ulo);
    ulo++;
  }
  printf("\n");
  unsigned char uch1, uch2, uch3;
  uch1 = 200;
  uch2 =  60;
  uch3 = uch1 + uch2;
  printf("\nAddition rebouclante de deux uchar (fausse) : %d + %d = %d \n", uch1, uch2, uch3);

  return 0;
}