// fic_stock.c
#include <stdio.h>
#include <stdlib.h>

char *debut = "AAAA";
int   ndx, numelem[5] = {0};
int   Article[5] = {2340,  87520, 124,  12520, 1987};
float Prix[5]    = {3.40, 75.20,  12.4, 25.20, 9.87};

void Visualiser(int enreg);

int main()
{
  int qte = 5;
  FILE *fh;
  char ts[10+1];
  char nomfic[] = "fic_stock.bin";

  for ( ndx=0; ndx < qte; ndx++) {
    numelem[ndx] = (short)ndx;
    Visualiser(ndx);
  }

  fh = fopen(nomfic, "wb+");
  if( !fh ) {
    puts("Ouverture impossible");
    return(1);
  }

  for ( ndx=0; ndx < qte; ndx++) {
    numelem[ndx] = ndx;
    fwrite(debut, 4, 1, fh);
    fwrite(&numelem[ndx], sizeof(int), 1, fh);
    fwrite(&Article[ndx], sizeof(int), 1, fh);
    fwrite(&Prix[ndx], sizeof(float), 1, fh);
  }

  printf("\n\nSaisir 0, 16, 32 ou 48 :\n");
  int decala;
  decala = atoi(fgets(ts, 10, stdin) );
  printf("\n\n DECALA = %d", decala);

  fseek(fh, decala, SEEK_END);
  for ( ndx=0; ndx < 2; ndx++) {
    numelem[ndx] = ndx;
    fread(debut, 4, 1, fh);
    fread(&numelem[ndx], sizeof(int), 1, fh);
    fread(&Article[ndx], sizeof(int), 1, fh);
    fread(&Prix[ndx], sizeof(float), 1, fh);
    Visualiser(ndx);
  }

  fclose(fh);
  return(0);
}

void Visualiser(int enreg) {
  printf("\n\n Indice ndx = %d",   ndx);
  printf("\n Debut   = %s",   debut);
  printf("\n Numelem = %d",   numelem[enreg]);
  printf("\n Reference: %5d",   Article[enreg]);
  printf("\n     Prix : %4.2f", Prix[enreg]);
}