// lib_printf.c
#include <stdio.h>
#include <stdlib.h>

int main(void)
{
  char   icVal  =        117;
  int    i_Val  =   16777217;
  long long iLVal  = 12345678912345678;
  float  f_Val  =   -4325.25;
  double fdVal  = 1.81794E-3;
  char  stVal[] = "Je sers de phrase de test.";
  int* ptrIVal = &i_Val;

  printf("\n*** Tests de printf() ***\n");
  printf("Valeur char avec d = %d\n", icVal);
  printf("Valeur char avec c = %c\n", icVal);

  printf("\n*** Tests de cadrage sur int ***\n");
  printf("Valeur int avec d    = |%d|||\n", i_Val);
  printf("Valeur int avec -12d = |%-12d|||\n", i_Val);
  printf("Avec 12d et signe +  = |%+12d|||\n", i_Val);
  printf("Ligne de reperage    = |****99999999|||\n");
  printf("16300 en hexadecimal = |%X|\n", 16300); 
  printf("Valeur long long     = |%llu|||\n", iLVal);

  printf("\n*** Tests de cadrage sur float ***\n");
  printf("Valeur float avec f    = |%f|||\n", f_Val);
  printf("Valeur int avec 5.1f   = |%5.1f|||\n", f_Val);
  printf("Valeur int avec 3.5f   = |%3.5f|||\n", f_Val);

  printf("\nValeur double avec e    = |%e|||\n", fdVal);
  printf("Valeur double avec f    = |%f|||\n", fdVal);
  printf("Valeur double avec 5.9f = |%5.1f|||\n", fdVal);

  printf("\n*** Tests de cadrage sur tableaux chaines ***\n");
  printf("Valeur chaine avec s    = |%s|||\n", stVal);
  printf("Valeur chaine avec 30s  = |%30s|||\n", stVal);
  printf("Valeur chaine avec -10s = |%-10s|||\n", stVal);

  printf("\n*** On finit avec un pointeur ***\n");
  printf("Valeur de pointeur avec p  = |%p|\n", ptrIVal);
  printf("Contenu de cette adresse   = |%d|\n", *ptrIVal);
 
  return 0;
}